diff --git a/src/backend/catalog/partition.c b/src/backend/catalog/partition.c
index 98fed55..66537cf 100644
--- a/src/backend/catalog/partition.c
+++ b/src/backend/catalog/partition.c
@@ -2078,7 +2078,6 @@ find_partition_scheme(PlannerInfo *root, Relation relation)
 	int		nparts;
 	int		partnatts;
 	int		cnt_pks;
-	int		cnt_parts;
 	PartitionScheme	part_scheme = NULL;
 
 	/* No partition scheme for an unpartitioned relation. */
@@ -2088,21 +2087,6 @@ find_partition_scheme(PlannerInfo *root, Relation relation)
 	nparts = part_desc->nparts;
 	partnatts = part_key->partnatts;
 
-	/*
-	 * For a multi-level partitioned table, we do not retain the partitioning
-	 * hierarchy while expanding RTE for the topmost parent. Thus the number of
-	 * children as per root->append_rel_list does not match the number of
-	 * partitions specified in the partition descriptor and hence the
-	 * partitioning scheme of a multi-partitioned table does not reflect the
-	 * true picture. So for now, treat a multi-partitioned table as not
-	 * partitioned.
-	 */
-	for (cnt_parts = 0; cnt_parts < nparts; cnt_parts++)
-	{
-		if (has_subclass(part_desc->oids[cnt_parts]))
-			return NULL;
-	}
-
 	/* Search for a matching partition scheme and return if found one. */
 	foreach (lc, root->part_schemes)
 	{
diff --git a/src/backend/optimizer/path/allpaths.c b/src/backend/optimizer/path/allpaths.c
index 0a2c131..b8af23e 100644
--- a/src/backend/optimizer/path/allpaths.c
+++ b/src/backend/optimizer/path/allpaths.c
@@ -98,9 +98,6 @@ static void set_append_rel_pathlist(PlannerInfo *root, RelOptInfo *rel,
 static void generate_mergeappend_paths(PlannerInfo *root, RelOptInfo *rel,
 						   List *live_childrels, List *all_child_pathkeys,
 						   bool partition_join_path);
-static Path *get_cheapest_parameterized_child_path(PlannerInfo *root,
-									  RelOptInfo *rel,
-									  Relids required_outer);
 static List *accumulate_append_subpath(List *subpaths, Path *path);
 static void set_subquery_pathlist(PlannerInfo *root, RelOptInfo *rel,
 					  Index rti, RangeTblEntry *rte);
@@ -1646,7 +1643,7 @@ generate_mergeappend_paths(PlannerInfo *root, RelOptInfo *rel,
  *
  * Returns NULL if unable to create such a path.
  */
-static Path *
+Path *
 get_cheapest_parameterized_child_path(PlannerInfo *root, RelOptInfo *rel,
 									  Relids required_outer)
 {
diff --git a/src/backend/optimizer/path/joinrels.c b/src/backend/optimizer/path/joinrels.c
index 7839f0f..e7e06c8 100644
--- a/src/backend/optimizer/path/joinrels.c
+++ b/src/backend/optimizer/path/joinrels.c
@@ -1526,7 +1526,6 @@ add_paths_to_child_joinrel(PlannerInfo *root, RelOptInfo *parent_joinrel,
 											   child_rel1->relids,
 											   child_rel2->relids);
 
-
 		/*
 		 * Construct restrictions applicable to the child join from
 		 * those applicable to the parent join.
@@ -1619,6 +1618,58 @@ adjust_child_relids(Relids relids, List *append_rel_infos)
 }
 
 /*
+ * Replace any relid present in top_parent_relids with its child in
+ * child_relids. Members of child_relids can be multiple levels below top
+ * parent in the partition hierarchy.
+ */
+Relids
+adjust_child_relids_multilevel(PlannerInfo *root, Relids relids,
+							   Relids child_relids, Relids top_parent_relids)
+{
+	List	   *appinfos;
+	Relids		parent_relids = NULL;
+	ListCell   *lc;
+	Relids		result;
+	Relids		tmp_result = NULL;
+
+	/*
+	 * If the given relids set doesn't contain any of the top parent relids,
+	 * it will remain unchanged.
+	 */
+	if (!bms_overlap(relids, top_parent_relids))
+		return relids;
+
+	appinfos = find_appinfos_by_relids(root, child_relids);
+
+	/* Construct relids set for the immediate parent of the given child. */
+	foreach (lc, appinfos)
+	{
+		AppendRelInfo   *appinfo = lfirst(lc);
+
+		parent_relids = bms_add_member(parent_relids, appinfo->parent_relid);
+	}
+
+	/* Recurse if immediate parent is not the top parent. */
+	if (!bms_equal(parent_relids, top_parent_relids))
+	{
+		tmp_result = adjust_child_relids_multilevel(root, relids,
+													parent_relids,
+													top_parent_relids);
+		relids = tmp_result;
+	}
+
+	result = adjust_child_relids(relids, appinfos);
+
+	/* Free memory consumed by any immediate result. */
+	if (tmp_result)
+		bms_free(tmp_result);
+
+	bms_free(parent_relids);
+	list_free(appinfos);
+	return result;
+}
+
+/*
  * Returns true if there exists an equi-join condition for each pair of
  * partition key from given relations being joined.
  */
diff --git a/src/backend/optimizer/plan/createplan.c b/src/backend/optimizer/plan/createplan.c
index 3a223c8..baf0fdf 100644
--- a/src/backend/optimizer/plan/createplan.c
+++ b/src/backend/optimizer/plan/createplan.c
@@ -4097,13 +4097,32 @@ create_partition_join_plan(PlannerInfo *root, PartitionJoinPath *best_path)
 		 * Search for a child path with pathkeys or parameterization
 		 * matching that of the given path.
 		 */
-		child_path = get_cheapest_path_for_pathkeys(child_join->pathlist,
-													best_path->path.pathkeys,
-											 PATH_REQ_OUTER(&best_path->path),
-													TOTAL_COST);
+		if (!PATH_REQ_OUTER(&best_path->path))
+			child_path = get_cheapest_path_for_pathkeys(child_join->pathlist,
+													  best_path->path.pathkeys,
+														NULL,
+														TOTAL_COST);
+		else if (best_path->reparamterized_by)
+		{
+			child_path = get_cheapest_parameterized_child_path(root,
+															   child_join,
+													best_path->old_param);
+
+			if (!child_path)
+				elog(ERROR, "Could not find a child-join path with required pathkeys or parameterization.");
+
+			child_path = reparameterize_path_by_child(root, child_path,
+												 best_path->reparamterized_by);
+		}
+		else
+			child_path = get_cheapest_parameterized_child_path(root,
+															   child_join,
+											  PATH_REQ_OUTER(&best_path->path));
 
 		if (!child_path)
-			elog(ERROR, "Could not find a path with required pathkeys.");
+			elog(ERROR, "Could not find a child-join path with required pathkeys or parameterization.");
+
+		MemoryContextSwitchTo(old_context);
 
 		MemoryContextSwitchTo(old_context);
 
@@ -4155,7 +4174,19 @@ create_partition_join_plan(PlannerInfo *root, PartitionJoinPath *best_path)
 			}
 		}
 
-		child_plans = lappend(child_plans, child_plan);
+		/* Flatten Merge/Append plans. */
+		if (IsA(child_plan, Append))
+		{
+			Append	   *append = (Append *) child_plan;
+			child_plans = list_concat(child_plans, append->appendplans);
+		}
+		else if (IsA(child_plan, MergeAppend))
+		{
+			MergeAppend	   *mappend = (MergeAppend *) child_plan;
+			child_plans = list_concat(child_plans, mappend->mergeplans);
+		}
+		else
+			child_plans = lappend(child_plans, child_plan);
 
 		/*
 		 * Reset the child_join memory context to reclaim the memory consumed
diff --git a/src/backend/optimizer/plan/initsplan.c b/src/backend/optimizer/plan/initsplan.c
index 84ce6b3..61f3886 100644
--- a/src/backend/optimizer/plan/initsplan.c
+++ b/src/backend/optimizer/plan/initsplan.c
@@ -14,6 +14,7 @@
  */
 #include "postgres.h"
 
+#include "catalog/pg_class.h"
 #include "catalog/pg_type.h"
 #include "nodes/nodeFuncs.h"
 #include "optimizer/clauses.h"
@@ -623,8 +624,22 @@ create_lateral_join_info(PlannerInfo *root)
 	for (rti = 1; rti < root->simple_rel_array_size; rti++)
 	{
 		RelOptInfo *brel = root->simple_rel_array[rti];
+		RangeTblEntry *rte = root->simple_rte_array[rti];
 
-		if (brel == NULL || brel->reloptkind != RELOPT_BASEREL)
+		if (brel == NULL)
+			continue;
+
+		/*
+		 * If an "other rel" RTE is a "partitioned table", we must propagate
+		 * the lateral info inherited all the way from the root parent to its
+		 * children. That's because the children are not linked directly with
+		 * the root parent via AppendRelInfo's unlike in case of a regular
+		 * inheritance set (see expand_inherited_rtentry()).  Failing to
+		 * do this would result in those children not getting marked with the
+		 * appropriate lateral info.
+		 */
+		if (brel->reloptkind != RELOPT_BASEREL &&
+			rte->relkind != RELKIND_PARTITIONED_TABLE)
 			continue;
 
 		if (root->simple_rte_array[rti]->inh)
diff --git a/src/backend/optimizer/prep/prepunion.c b/src/backend/optimizer/prep/prepunion.c
index 8b6a183..ecaffd0 100644
--- a/src/backend/optimizer/prep/prepunion.c
+++ b/src/backend/optimizer/prep/prepunion.c
@@ -110,6 +110,14 @@ static Node *adjust_appendrel_attrs_mutator(Node *node,
 							   adjust_appendrel_attrs_context *context);
 static List *adjust_inherited_tlist(List *tlist,
 					   AppendRelInfo *context);
+static List *expand_inherited_rte_internal(PlannerInfo *root, RangeTblEntry *rte,
+							 Index rti, PlanRowMark *oldrc,
+							 LOCKMODE lockmode, bool flatten);
+static AppendRelInfo *process_one_child_table(PlannerInfo *root,
+						RangeTblEntry *parentRTE, Index parentRTindex,
+						Relation parentrel, Relation childrel,
+						PlanRowMark *parent_rc, bool inh,
+						RangeTblEntry **childRTE, Index *childRTindex);
 
 
 /*
@@ -1323,7 +1331,10 @@ expand_inherited_tables(PlannerInfo *root)
 
 	/*
 	 * expand_inherited_rtentry may add RTEs to parse->rtable; there is no
-	 * need to scan them since they can't have inh=true.  So just scan as far
+	 * need to scan them here since they can't normally have inh=true.  If
+	 * the inheritance set represents a partitioned table, some newly added
+	 * RTEs will break the above rule if they are partitioned tables
+	 * themselves, but they are expanded recursively.  So just scan as far
 	 * as the original end of the rtable list.
 	 */
 	nrtes = list_length(root->parse->rtable);
@@ -1346,9 +1357,11 @@ expand_inherited_tables(PlannerInfo *root)
  *		"inh" flag to prevent later code from looking for AppendRelInfos.
  *
  * Note that the original RTE is considered to represent the whole
- * inheritance set.  The first of the generated RTEs is an RTE for the same
- * table, but with inh = false, to represent the parent table in its role
- * as a simple member of the inheritance set.
+ * inheritance set.  If the RTE represents a partitioned table, inheritance
+ * set is expanded recursively.  The first of the generated RTEs is an RTE
+ * for the same table, but with inh = false, to represent the parent table
+ * in its role as a simple member of the inheritance set.  The same applies
+ * to each individual inheritance set in the recursive expansion case.
  *
  * A childless table is never considered to be an inheritance set; therefore
  * a parent RTE must always have at least two associated AppendRelInfos.
@@ -1359,11 +1372,8 @@ expand_inherited_rtentry(PlannerInfo *root, RangeTblEntry *rte, Index rti)
 	Query	   *parse = root->parse;
 	Oid			parentOID;
 	PlanRowMark *oldrc;
-	Relation	oldrelation;
 	LOCKMODE	lockmode;
-	List	   *inhOIDs;
 	List	   *appinfos;
-	ListCell   *l;
 
 	/* Does RT entry allow inheritance? */
 	if (!rte->inh)
@@ -1404,19 +1414,69 @@ expand_inherited_rtentry(PlannerInfo *root, RangeTblEntry *rte, Index rti)
 	else
 		lockmode = AccessShareLock;
 
-	/* Scan for all members of inheritance set, acquire needed locks */
-	inhOIDs = find_all_inheritors(parentOID, lockmode, NULL);
+	/*
+	 * Do not flatten the inheritance hierarchy if partitioned table, unless
+	 * this is the result relation.
+	 */
+	if (rte->relkind == RELKIND_PARTITIONED_TABLE &&
+		rti != root->parse->resultRelation)
+		appinfos = expand_inherited_rte_internal(root, rte, rti, oldrc,
+												 lockmode, false);
+	else
+		appinfos = expand_inherited_rte_internal(root, rte, rti, oldrc,
+												 lockmode, true);
+
+	/* Add to root->append_rel_list */
+	root->append_rel_list = list_concat(root->append_rel_list, appinfos);
+}
+
+/*
+ * expand_inherited_rte_internal
+ *		Expand an inheritance set in either non-recursive (flatten=true) or
+ *		recursive (flatten=false) manner.
+ *
+ * A inheritance hierarchy is not flttened if it represents a partitioned
+ * table.  This allows later planning steps to apply any partitioning
+ * related optimizations in suitable manner.
+ */
+static List *
+expand_inherited_rte_internal(PlannerInfo *root, RangeTblEntry *rte,
+							  Index rti, PlanRowMark *oldrc,
+							  LOCKMODE lockmode, bool flatten)
+{
+	Oid			parentOID;
+	Relation	oldrelation;
+	List	   *inhOIDs;
+	List	   *appinfos = NIL;
+	ListCell   *l;
+	bool		has_descendents;
+
+	Assert(rte->rtekind == RTE_RELATION);
+	parentOID = rte->relid;
 
 	/*
-	 * Check that there's at least one descendant, else treat as no-child
+	 * Get the list of inheritors.
+	 *
+	 * Also check that there's at least one descendant, else treat as no-child
 	 * case.  This could happen despite above has_subclass() check, if table
 	 * once had a child but no longer does.
 	 */
-	if (list_length(inhOIDs) < 2)
+	if (flatten)
+	{
+		inhOIDs = find_all_inheritors(parentOID, lockmode, NULL);
+		has_descendents = list_length(inhOIDs) >= 2;
+	}
+	else
+	{
+		inhOIDs = find_inheritance_children(parentOID, lockmode);
+		has_descendents = list_length(inhOIDs) >= 1;
+	}
+
+	if (!has_descendents)
 	{
 		/* Clear flag before returning */
 		rte->inh = false;
-		return;
+		return NIL;
 	}
 
 	/*
@@ -1433,15 +1493,24 @@ expand_inherited_rtentry(PlannerInfo *root, RangeTblEntry *rte, Index rti)
 	 */
 	oldrelation = heap_open(parentOID, NoLock);
 
+	/*
+	 * Process parent relation in its role as inheritance set member; remember
+	 * that parent table OID is not in inhOIDs if we did not flatten the
+	 * inheritance tree.
+	 */
+	if (!flatten)
+		appinfos = list_make1(process_one_child_table(root, rte, rti,
+													  oldrelation, oldrelation,
+													  oldrc, false,
+													  NULL, NULL));
+
 	/* Scan the inheritance set and expand it */
-	appinfos = NIL;
 	foreach(l, inhOIDs)
 	{
 		Oid			childOID = lfirst_oid(l);
 		Relation	newrelation;
 		RangeTblEntry *childrte;
 		Index		childRTindex;
-		AppendRelInfo *appinfo;
 
 		/* Open rel if needed; we already have required locks */
 		if (childOID != parentOID)
@@ -1462,75 +1531,29 @@ expand_inherited_rtentry(PlannerInfo *root, RangeTblEntry *rte, Index rti)
 		}
 
 		/*
-		 * Build an RTE for the child, and attach to query's rangetable list.
-		 * We copy most fields of the parent's RTE, but replace relation OID
-		 * and relkind, and set inh = false.  Also, set requiredPerms to zero
-		 * since all required permissions checks are done on the original RTE.
-		 */
-		childrte = copyObject(rte);
-		childrte->relid = childOID;
-		childrte->relkind = newrelation->rd_rel->relkind;
-		childrte->inh = false;
-		childrte->requiredPerms = 0;
-		parse->rtable = lappend(parse->rtable, childrte);
-		childRTindex = list_length(parse->rtable);
-
-		/*
-		 * Build an AppendRelInfo for this parent and child.
-		 */
-		appinfo = makeNode(AppendRelInfo);
-		appinfo->parent_relid = rti;
-		appinfo->child_relid = childRTindex;
-		appinfo->parent_reltype = oldrelation->rd_rel->reltype;
-		appinfo->child_reltype = newrelation->rd_rel->reltype;
-		make_inh_translation_list(oldrelation, newrelation, childRTindex,
-								  &appinfo->translated_vars);
-		appinfo->parent_reloid = parentOID;
-		appinfos = lappend(appinfos, appinfo);
-
-		/*
-		 * Translate the column permissions bitmaps to the child's attnums (we
-		 * have to build the translated_vars list before we can do this). But
-		 * if this is the parent table, leave copyObject's result alone.
+		 * process_one_child_table() performs the following actions for the
+		 * child table:
 		 *
-		 * Note: we need to do this even though the executor won't run any
-		 * permissions checks on the child RTE.  The insertedCols/updatedCols
-		 * bitmaps may be examined for trigger-firing purposes.
-		 */
-		if (childOID != parentOID)
-		{
-			childrte->selectedCols = translate_col_privs(rte->selectedCols,
-												   appinfo->translated_vars);
-			childrte->insertedCols = translate_col_privs(rte->insertedCols,
-												   appinfo->translated_vars);
-			childrte->updatedCols = translate_col_privs(rte->updatedCols,
-												   appinfo->translated_vars);
-		}
-
-		/*
-		 * Build a PlanRowMark if parent is marked FOR UPDATE/SHARE.
+		 * 1. add a new RTE to the query rtable,
+		 * 2. builds a PlanRowMark and adds to the root->rowMarks list
+		 * 3. builds and returns AppendRelInfo for parent-child pair
 		 */
-		if (oldrc)
+		appinfos = lappend(appinfos,
+						   process_one_child_table(root, rte, rti,
+												   oldrelation, newrelation,
+												   oldrc, false,
+												   &childrte, &childRTindex));
+
+		/* Recurse if we did not flatten the inheritance tree */
+		if (!flatten && has_subclass(childOID))
 		{
-			PlanRowMark *newrc = makeNode(PlanRowMark);
-
-			newrc->rti = childRTindex;
-			newrc->prti = rti;
-			newrc->rowmarkId = oldrc->rowmarkId;
-			/* Reselect rowmark type, because relkind might not match parent */
-			newrc->markType = select_rowmark_type(childrte, oldrc->strength);
-			newrc->allMarkTypes = (1 << newrc->markType);
-			newrc->strength = oldrc->strength;
-			newrc->waitPolicy = oldrc->waitPolicy;
-			newrc->isParent = false;
-
-			/* Include child's rowmark type in parent's allMarkTypes */
-			oldrc->allMarkTypes |= newrc->allMarkTypes;
-
-			root->rowMarks = lappend(root->rowMarks, newrc);
+			Assert(childrte->relkind == RELKIND_PARTITIONED_TABLE);
+			childrte->inh = true;
+			appinfos = list_concat(appinfos,
+							   expand_inherited_rte_internal(root, childrte,
+										childRTindex, oldrc, lockmode, flatten));
 		}
 
-		/* Close child relations, but keep locks */
 		if (childOID != parentOID)
 			heap_close(newrelation, NoLock);
 	}
@@ -1546,11 +1569,108 @@ expand_inherited_rtentry(PlannerInfo *root, RangeTblEntry *rte, Index rti)
 	{
 		/* Clear flag before returning */
 		rte->inh = false;
-		return;
+		return NIL;
 	}
+	return appinfos;
+}
 
-	/* Otherwise, OK to add to root->append_rel_list */
-	root->append_rel_list = list_concat(root->append_rel_list, appinfos);
+/*
+ * process_one_child_table
+ *		Process one child table in context of inheritance expansion for a
+ *		query
+ *
+ * *childRTE & *childRTindex are output variables when non-NULL.
+ */
+static AppendRelInfo *
+process_one_child_table(PlannerInfo *root,
+						RangeTblEntry *parentRTE, Index parentRTindex,
+						Relation parentrel, Relation childrel,
+						PlanRowMark *parent_rc, bool inh,
+						RangeTblEntry **childRTE, Index *childRTindex)
+{
+	Query  *parse = root->parse;
+	Oid		parentOID = RelationGetRelid(parentrel),
+			childOID = RelationGetRelid(childrel);
+	RangeTblEntry  *newrte;
+	Index			newrti;
+	AppendRelInfo  *appinfo;
+
+	/*
+	 * Build an RTE for the child, and attach to query's rangetable list.
+	 * We copy most fields of the parent's RTE, but replace relation OID
+	 * and relkind, and set inh as requested.  Also, set requiredPerms to
+	 * zero since all required permissions checks are done on the original
+	 * RTE.
+	 */
+	newrte = copyObject(parentRTE);
+	newrte->relid = RelationGetRelid(childrel);
+	newrte->relkind = childrel->rd_rel->relkind;
+	newrte->inh = inh;
+	newrte->requiredPerms = 0;
+	parse->rtable = lappend(parse->rtable, newrte);
+	newrti = list_length(parse->rtable);
+
+	/* Return the child table RT entry and index if requested */
+	if (childRTE)
+		*childRTE = newrte;
+	if (childRTindex)
+		*childRTindex = newrti;
+
+	/*
+	 * Build an AppendRelInfo for this parent and child.
+	 */
+	appinfo = makeNode(AppendRelInfo);
+	appinfo->parent_relid = parentRTindex;
+	appinfo->child_relid = newrti;
+	appinfo->parent_reltype = parentrel->rd_rel->reltype;
+	appinfo->child_reltype = childrel->rd_rel->reltype;
+	make_inh_translation_list(parentrel, childrel, newrti,
+							  &appinfo->translated_vars);
+	appinfo->parent_reloid = parentOID;
+
+	/*
+	 * Translate the column permissions bitmaps to the child's attnums (we
+	 * have to build the translated_vars list before we can do this). But
+	 * if this is the parent table, leave copyObject's result alone.
+	 *
+	 * Note: we need to do this even though the executor won't run any
+	 * permissions checks on the child RTE.  The insertedCols/updatedCols
+	 * bitmaps may be examined for trigger-firing purposes.
+	 */
+	if (childOID != parentOID)
+	{
+		newrte->selectedCols = translate_col_privs(parentRTE->selectedCols,
+											   appinfo->translated_vars);
+		newrte->insertedCols = translate_col_privs(parentRTE->insertedCols,
+											   appinfo->translated_vars);
+		newrte->updatedCols = translate_col_privs(parentRTE->updatedCols,
+											   appinfo->translated_vars);
+	}
+
+	/*
+	 * Build a PlanRowMark if parent is marked FOR UPDATE/SHARE.
+	 */
+	if (parent_rc)
+	{
+		PlanRowMark *newrc = makeNode(PlanRowMark);
+
+		newrc->rti = newrti;
+		newrc->prti = parentRTindex;
+		newrc->rowmarkId = parent_rc->rowmarkId;
+		/* Reselect rowmark type, because relkind might not match parent */
+		newrc->markType = select_rowmark_type(newrte, parent_rc->strength);
+		newrc->allMarkTypes = (1 << newrc->markType);
+		newrc->strength = parent_rc->strength;
+		newrc->waitPolicy = parent_rc->waitPolicy;
+		newrc->isParent = false;
+
+		/* Include child's rowmark type in parent's allMarkTypes */
+		parent_rc->allMarkTypes |= newrc->allMarkTypes;
+
+		root->rowMarks = lappend(root->rowMarks, newrc);
+	}
+
+	return appinfo;
 }
 
 /*
@@ -2166,23 +2286,47 @@ adjust_inherited_tlist(List *tlist, AppendRelInfo *context)
  * adjust_appendrel_attrs_multilevel
  *	  Apply Var translations from a toplevel appendrel parent down to a child.
  *
- * In some cases we need to translate expressions referencing a baserel
+ * In some cases we need to translate expressions referencing a parent relation
  * to reference an appendrel child that's multiple levels removed from it.
  */
 Node *
 adjust_appendrel_attrs_multilevel(PlannerInfo *root, Node *node,
 								  RelOptInfo *child_rel)
 {
-	AppendRelInfo *appinfo = find_childrel_appendrelinfo(root, child_rel);
-	RelOptInfo *parent_rel = find_base_rel(root, appinfo->parent_relid);
+	List	   *appinfos = find_appinfos_by_relids(root, child_rel->relids);
+	RelOptInfo *parent_rel;
+
+	if (child_rel->reloptkind == RELOPT_OTHER_MEMBER_REL)
+	{
+		AppendRelInfo *appinfo = linitial(appinfos);
+		parent_rel = find_base_rel(root, appinfo->parent_relid);
+	}
+	else
+	{
+		Relids		parent_relids = NULL;
+		ListCell   *lc;
+
+		/* Construct relids set for the immediate parent of the given child. */
+		foreach (lc, appinfos)
+		{
+			AppendRelInfo   *appinfo = lfirst(lc);
+
+			parent_relids = bms_add_member(parent_relids, appinfo->parent_relid);
+		}
+
+		parent_rel = find_join_rel(root, parent_relids);
+		bms_free(parent_relids);
+	}
 
 	/* If parent is also a child, first recurse to apply its translations */
-	if (parent_rel->reloptkind == RELOPT_OTHER_MEMBER_REL)
+	if (IS_OTHER_REL(parent_rel))
 		node = adjust_appendrel_attrs_multilevel(root, node, parent_rel);
 	else
-		Assert(parent_rel->reloptkind == RELOPT_BASEREL);
+		Assert(parent_rel->reloptkind == RELOPT_BASEREL ||
+			   parent_rel->reloptkind == RELOPT_JOINREL);
+
 	/* Now translate for this child */
-	return adjust_appendrel_attrs(root, node, list_make1(appinfo));
+	return adjust_appendrel_attrs(root, node, appinfos);
 }
 
 /*
@@ -2210,7 +2354,6 @@ build_child_restrictinfo(PlannerInfo *root, RestrictInfo *rinfo,
 	child_required_relids = adjust_child_relids(rinfo->required_relids,
 												append_rel_infos);
 
-
 	/* Nothing to do, if the clause does not need any translation. */
 	if (bms_equal(child_required_relids, rinfo->required_relids))
 	{
@@ -2279,3 +2422,50 @@ build_child_clauses(PlannerInfo *root, List *clauses, List *append_rel_infos)
 
 	return child_clauses;
 }
+
+/*
+ * build_child_clauses_multilevel
+ *		Similar to build_child_clauses but used when the child relation
+ *		represented by child_relids is
+ *		deeper down in the partition hierarchy reprepresented by parent
+ *		relation with relids top_parent_relids.
+ */
+List *
+build_child_clauses_multilevel(PlannerInfo *root, List *clauses,
+							   Relids child_relids, Relids top_parent_relids)
+{
+	List	   *appinfos;
+	Relids		parent_relids = NULL;
+	ListCell   *lc;
+	List	   *result;
+	List	   *tmp_result = NIL;
+
+	appinfos = find_appinfos_by_relids(root, child_relids);
+
+	/* Construct relids set for the immediate parent of the given child. */
+	foreach (lc, appinfos)
+	{
+		AppendRelInfo   *appinfo = lfirst(lc);
+
+		parent_relids = bms_add_member(parent_relids, appinfo->parent_relid);
+	}
+
+	/* Recurse if immediate parent is not the top parent. */
+	if (!bms_equal(parent_relids, top_parent_relids))
+	{
+		clauses = build_child_clauses_multilevel(root, clauses, parent_relids,
+												  top_parent_relids);
+		tmp_result = clauses;
+	}
+
+	result = build_child_clauses(root, clauses, appinfos);
+
+	/* Free memory consumed by any itermediate list. */
+	if (tmp_result)
+		list_free(tmp_result);
+
+	bms_free(parent_relids);
+	list_free(appinfos);
+
+	return result;
+}
diff --git a/src/backend/optimizer/util/pathnode.c b/src/backend/optimizer/util/pathnode.c
index f5010e4..2fa0023 100644
--- a/src/backend/optimizer/util/pathnode.c
+++ b/src/backend/optimizer/util/pathnode.c
@@ -3403,7 +3403,6 @@ reparameterize_path_by_child(PlannerInfo *root, Path *path,
 	Path	   *new_path;
 	ParamPathInfo   *new_ppi;
 	ParamPathInfo   *old_ppi;
-	List	   *child_aris;
 	Relids		required_outer;
 
 	/*
@@ -3446,6 +3445,11 @@ reparameterize_path_by_child(PlannerInfo *root, Path *path,
 			memcpy(new_path, path, sizeof(AppendPath));
 			break;
 
+		case T_PartitionJoinPath:
+			new_path = (Path *) makeNode(PartitionJoinPath);
+			memcpy(new_path, path, sizeof(PartitionJoinPath));
+			break;
+
 		/*
 		 * TODO:
 		 * If this method of translation is fine add more path types here.
@@ -3456,16 +3460,12 @@ reparameterize_path_by_child(PlannerInfo *root, Path *path,
 			return NULL;
 	}
 
-	/*
-	 * Gather AppendRelInfos of the base partition relations in the outer child
-	 * relation. We need those for translating parent path to that of child by
-	 * substituting parent Var nodes and relids with those of children.
-	 */
-	child_aris = find_appinfos_by_relids(root, child_rel->relids);
-
 	/* Adjust the parameterization information. */
 	old_ppi = new_path->param_info;
-	required_outer = adjust_child_relids(old_ppi->ppi_req_outer, child_aris);
+	required_outer = adjust_child_relids_multilevel(root,
+													old_ppi->ppi_req_outer,
+													child_rel->relids,
+												 child_rel->top_parent_relids);
 
 	/* If we already have a PPI for this parameterization, just return it */
 	new_ppi = find_param_path_info(new_path->parent, required_outer);
@@ -3476,8 +3476,10 @@ reparameterize_path_by_child(PlannerInfo *root, Path *path,
 		new_ppi = makeNode(ParamPathInfo);
 		new_ppi->ppi_req_outer = required_outer;
 		new_ppi->ppi_rows = old_ppi->ppi_rows;
-		new_ppi->ppi_clauses = build_child_clauses(root, old_ppi->ppi_clauses,
-												   child_aris);
+		new_ppi->ppi_clauses = build_child_clauses_multilevel(root,
+														  old_ppi->ppi_clauses,
+															 child_rel->relids,
+												 child_rel->top_parent_relids);
 		new_path->parent->ppilist = lappend(new_path->parent->ppilist, new_ppi);
 	}
 	else
@@ -3493,6 +3495,7 @@ reparameterize_path_by_child(PlannerInfo *root, Path *path,
 	if (bms_overlap(path->parent->lateral_relids, child_rel->top_parent_relids))
 	{
 		MemoryContext	old_context;
+		List	   *exprs;
 
 		/*
 		 * Allocate the target in planner's context, since they are copies as
@@ -3500,9 +3503,12 @@ reparameterize_path_by_child(PlannerInfo *root, Path *path,
 		 */
 		old_context = MemoryContextSwitchTo(root->planner_cxt);
 		new_path->pathtarget = copy_pathtarget(new_path->pathtarget);
-		new_path->pathtarget->exprs = (List *) adjust_appendrel_attrs(root,
-											(Node *) new_path->pathtarget->exprs,
-																	child_aris);
+		exprs = new_path->pathtarget->exprs;
+		exprs = (List *) adjust_appendrel_attrs_multilevel(root,
+														   (Node *) exprs,
+														   child_rel);
+		new_path->pathtarget->exprs = exprs;
+
 		MemoryContextSwitchTo(old_context);
 	}
 
@@ -3524,9 +3530,10 @@ reparameterize_path_by_child(PlannerInfo *root, Path *path,
 				jpath->innerjoinpath = reparameterize_path_by_child(root,
 														 jpath->innerjoinpath,
 														 child_rel);
-				jpath->joinrestrictinfo = build_child_clauses(root,
-															  jpath->joinrestrictinfo,
-															  child_aris);
+				jpath->joinrestrictinfo = build_child_clauses_multilevel(root,
+													  jpath->joinrestrictinfo,
+															child_rel->relids,
+												child_rel->top_parent_relids);
 			}
 			break;
 
@@ -3543,16 +3550,38 @@ reparameterize_path_by_child(PlannerInfo *root, Path *path,
 																	child_rel));
 				apath->subpaths = subpaths;
 			}
+			break;
 
 		case T_IndexPath:
 			{
 				IndexPath *ipath = (IndexPath *)new_path;
 
-				ipath->indexclauses = build_child_clauses(root, ipath->indexclauses,
-														  child_aris);
-				ipath->indexquals = build_child_clauses(root, ipath->indexquals,
-														child_aris);
+				ipath->indexclauses = build_child_clauses_multilevel(root,
+														   ipath->indexclauses,
+															 child_rel->relids,
+												 child_rel->top_parent_relids);
+
+				ipath->indexquals = build_child_clauses_multilevel(root,
+															 ipath->indexquals,
+															 child_rel->relids,
+												 child_rel->top_parent_relids);
 			}
+			break;
+
+		case T_PartitionJoinPath:
+			{
+				PartitionJoinPath *pjpath = (PartitionJoinPath *)new_path;	
+
+				/*
+				 * The paths for the child-joins covered by PartitionJoinPath will
+				 * be created later. If this PartitionJoinPath was reparameterized
+				 * by child of another relations, we will need that relation to
+				 * reparamterize the child-join paths.
+				 */
+				pjpath->old_param = PATH_REQ_OUTER(path); 
+				pjpath->reparamterized_by = child_rel;
+			}
+			break;
 
 		default:
 			/* Nothing to do. */
diff --git a/src/backend/optimizer/util/plancat.c b/src/backend/optimizer/util/plancat.c
index 88e66e4..83074e0 100644
--- a/src/backend/optimizer/util/plancat.c
+++ b/src/backend/optimizer/util/plancat.c
@@ -1335,8 +1335,13 @@ relation_excluded_by_constraints(PlannerInfo *root,
 	if (predicate_refuted_by(safe_restrictions, safe_restrictions))
 		return true;
 
-	/* Only plain relations have constraints */
-	if (rte->rtekind != RTE_RELATION || rte->inh)
+	/*
+	 * Only plain relations have constraints.  We represent a partitioned
+	 * table append member as its own append relation and hence would have
+	 * set rte->inh in that case.
+	 */
+	if (rte->rtekind != RTE_RELATION ||
+		(rte->inh && rte->relkind != RELKIND_PARTITIONED_TABLE))
 		return false;
 
 	/*
diff --git a/src/include/nodes/relation.h b/src/include/nodes/relation.h
index df5b60f..6bac09d 100644
--- a/src/include/nodes/relation.h
+++ b/src/include/nodes/relation.h
@@ -1515,6 +1515,12 @@ typedef struct LimitPath
 typedef struct PartitionJoinPath
 {
 	Path		path;
+
+	/* If this path is result of reparameterization by child. */
+	Relids		old_param;			/* Older parameterization. */
+	RelOptInfo *reparamterized_by;	/* Child relation by which this paths was
+									 * reparamterized.
+									 */
 } PartitionJoinPath;
 
 /*
